// http://arturadib.com/hello-backbonejs/docs

$(function(){
    var Todo = Backbone.Model.extend({
        defaults: {
            todo: "",
            complete: false
        }
    });

    var TodoList = Backbone.Collection.extend({
      model: Todo
    });

    var TodoView = Backbone.View.extend({
        tagName: 'li', 
        events: {
            "click button.toggle": function () {
                this.model.set('complete', !this.model.get('complete'));
                Application.render();
            }
        },
        render: function () {
            var checkbox_string = "<button class='toggle'>Toggle</button>";

            if (this.model.get('complete'))
            $(this.el).html("<del>" + checkbox_string + this.model.get('todo') + "</del>");
            else
            $(this.el).html(checkbox_string + this.model.get('todo'));
            return this;
        }
    });


    var TodoListView = Backbone.View.extend({
      el: $("body"),
      initialize: function () {
        this.collection = new TodoList();
      },

      addItem: function () {
            var todo = new Todo({todo: $("#new_todo_description").val()});
            this.collection.add(todo);
            this.render();
      },
      render: function () {
            $("#todos").html("<ul></ul>");
            _(this.collection.models).each(function(item){ // in case collection is not empty
                var todoView = new TodoView({model: item});
                $('ul', $("#todos")).append(todoView.render().el);                
            });

      },
      events: {
        "click button#new_item": "addItem"
      }
    });

    var Application = new TodoListView();
});
